#include <stdio.h>
#include <unistd.h>
#include <vga.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>

#define VGA_START_COMMAND 0x00ff5754

int pipe_fd[2];
int client_memfd;
int __svgalib_banked_mem_size, __svgalib_linear_mem_size;
unsigned char *__svgalib_banked_mem_base, *__svgalib_linear_mem_base, 
	*client_banked_mem_virtual, *client_linear_mem_virtual;
unsigned char *graph_mem;

void communicate(void )
{
	unsigned char c;
	int r;

	for(;;){
		if((r = read(pipe_fd[0], &c, 1)) != 1){
			fprintf(stderr, "Read reported: %d\n", r);
			exit(1);
		}
		if(!c) break;
		putchar(c);
	} 
}

#include "clientpart.c"	
			
int vga_init(void){
	int fd1[2], fd2[2], i[10];
	unsigned char c;
	
	pipe(fd1);
	pipe(fd2);
	if(!vfork()){
		close(0);
		dup(fd1[0]);
		close(fd1[0]);
		close(fd1[1]);
		close(1);
		dup(fd2[1]);
		close(fd2[1]);
		close(fd2[0]);
		if(execl("./server", 0)){
			fprintf(stderr, "svgalib client: could not find"
				" server.\n");
			exit(1);
		}
	} else {
		pipe_fd[1] = fd1[1];
		pipe_fd[0] = fd2[0];
		close(fd1[0]);
		close(fd2[1]);
		i[0] = VGA_START_COMMAND;
		i[1] = N_AGENFUN;
		write(pipe_fd[1], i, 8);
		communicate();
		read(pipe_fd[0], i, 20);
		client_memfd = open("/dev/svga", O_RDWR);
		if(client_memfd < 0){
			fprintf(stderr, "client: cannot open /dev/svga\n");
			exit(1);
		}
		__svgalib_banked_mem_size = i[2];
		__svgalib_banked_mem_base = (unsigned char *)i[1];
		__svgalib_linear_mem_size = i[4];
		__svgalib_linear_mem_base = (unsigned char *) i[3];
		printf("received banked: %x %d\n", i[1], i[2]);
		printf("received linear: %x %d\n", i[3], i[4]);
		if(__svgalib_banked_mem_size){
			client_banked_mem_virtual = mmap((caddr_t) 0,
					__svgalib_banked_mem_size,
					PROT_WRITE | PROT_READ, 
					MAP_SHARED,
					client_memfd,
					(off_t) __svgalib_banked_mem_base);
			
			if(((int)client_banked_mem_virtual) < 0){
				fprintf(stderr, "mmap failed.\n");
				exit(1);
			}
			graph_mem = client_banked_mem_virtual;
		} else graph_mem = 0;
		if(__svgalib_linear_mem_size){
			client_linear_mem_virtual = mmap((caddr_t) 0,
					__svgalib_linear_mem_size,
					PROT_WRITE |  PROT_READ, 
					MAP_SHARED,
					client_memfd,
					(off_t) __svgalib_linear_mem_base);
			
			if(((int)client_linear_mem_virtual) < 0){
				fprintf(stderr, "mmap failed.\n");
				exit(1);
			}
		}
		if((!graph_mem) && __svgalib_linear_mem_size)
			graph_mem = client_linear_mem_virtual;
	}
	return i[0]; 
}
unsigned char *vga_getgraphmem(void)
{
	return graph_mem;
}

int vga_setlinearaddressing(void)
{
	if(__svgalib_linear_mem_size){
	       graph_mem = client_linear_mem_virtual;
		return __svgalib_linear_mem_size;
	}
	return -1;
}

